#ifndef GTEST
#include "behavior_analyzer.h"
// #include "gflags/gflags.h"
#include "glog/logging.h"
// #include "rclcpp/rclcpp.hpp"
// #include "ros_recv.h"
#include "update_local_view.h"
// #include "param/paramconfig.h"
// #ifdef BA_RVIZ
//     #include "ba_rviz_display.h"
// #endif
#include "int_test.h"
#include "ara/log/logger.h"
using namespace ADC::planning;

#include <thread>
#include <chrono>
string FLAGS_root_dir = {"/home/igs/Desktop/02_RosbagData/GlogData"};
string FLAGS_data_dir = FLAGS_root_dir + "/data/";
string FLAGS_glog_dir = FLAGS_root_dir + "/log/";

/* DECLARE_string(root_dir);
DECLARE_string(data_dir);
DECLARE_string(glog_dir);
DECLARE_string(test_config_file);

DEFINE_string(root_dir, "/home/igs/Desktop/gflag/glog_files/glog_files_test",
              "root file addr");
DEFINE_string(data_dir, FLAGS_root_dir + "/data/", "data file addr");
DEFINE_string(glog_dir, FLAGS_root_dir + "/log/", "log file addr"); */
// DEFINE_string(test_config_file, "roadmodel_config.pb.txt",
//               "The roadmodel config file used in test");

int main(int argc, char **argv)
{
    dpc::ObjectTrim objectTrim;
    // dpc::VED4DPC DM_data_VED;
    // dpc::RoadInfo DM_data_RoadInfo;
//     dpc::RMHeader DM_data_RMHeader;
//     dpc::Index DM_data_Index;
//     dpc::CarPosition DM_data_CarPosition;
//     dpc::Lane DM_data_Lane;
//     dpc::LaneMarker DM_data_LaneMarker;
//     dpc::Object DM_data_Object;
//     dpc::RoadEdge DM_data_RoadEdge;
//     dpc::NeighborLane DM_data_NeighborLane;
//     dpc::Corridor DM_data_Corridor;
//     dpc::SamplingPoint DM_data_SamplingPoint;
//     dpc::LineColor DM_data_LineColor;
//     dpc::LineType DM_data_LineType;
//     dpc::ObjectLocation DM_data_ObjectLocation;
//     dpc::SLPoint DM_data_SLPoint;
//     dpc::LaneControl DM_data_LaneControl;
//     dpc::LaneBoundary DM_data_LaneBoundary;
//     dpc::LineGeometry DM_data_LineGeometry;
//     dpc::RoadEdgeSegment DM_data_RoadEdgeSegment;
//     dpc::AdjacentExtendLaneStruct DM_data_AdjacentExtendLaneStruct;
//     dpc::SMAStruct DM_data_SMAStruct;
//     dpc::WPExtendLaneStruct DM_data_WPExtendLaneStruct;
//     dpc::RemindWayPointStruct DM_data_RemindWayPointStruct;
//     dpc::ControlWayPointStruct DM_data_ControlWayPointStruct;
//     dpc::MsgHeader DM_data_MsgHeader;
//     dpc::TransitLaneStruct DM_data_TransitLaneStruct;
    // dpc::ControlWaypoints DM_data_ControlWayPoints;

    /**************************gflag initialization**************************/
    // gflags::ParseCommandLineFlags(&argc, &argv, true);

    /*******************glog initialization*******************/
    // setup_test(); 20240330: comment out this part
    google::InitGoogleLogging(argv[0]); // google的日志库

    FLAGS_logtostderr = false; // true: 设置日志消息转到标准输出 而不是日志文件
#ifdef GLOG
    FLAGS_alsologtostderr = false; // true: 设置日志消息除了日志文件之外也去标准输出
    FLAGS_colorlogtostderr = true; // true: log为彩色
    // FLAGS_max_log_size = 10;       // true: 设置最大日志文件大小（以MB为单位）
    const char *dir = FLAGS_glog_dir.c_str();
    /*   if (access(dir, 0) == -1)
  mkdir(dir, 00700);               //判断文件夹是否存在 若不存在则创建 */
    FLAGS_log_dir = FLAGS_glog_dir; // 有此句才可以输出日志文件

    FLAGS_v = 4; // 设置clog的输出级别 ADEBUG的级别是4 FLAGS_v小于4时不打印ADEBUG

    // 设置特定严重级别的日志的输出目录和前缀。第一个参数为日志级别，第二个参数表示输出目录及日志文件名前缀
    google::SetLogDestination(google::GLOG_INFO,
                              (FLAGS_glog_dir + "INFO_").c_str());
    google::SetLogDestination(google::GLOG_WARNING,
                              (FLAGS_glog_dir + "WARNING_").c_str());
    google::SetLogDestination(google::GLOG_ERROR,
                              (FLAGS_glog_dir + "ERROR_").c_str());
    google::SetLogDestination(google::GLOG_FATAL,
                              (FLAGS_glog_dir + "FATAL_").c_str());
#endif

    /*******************ros communication initialization*******************/
    // rclcpp::init(argc, argv);
    // rclcpp::executors::SingleThreadedExecutor executor; // single thread
    // rclcpp::executors::MultiThreadedExecutor executor(rclcpp::ExecutorOptions(), 3); // multiple thread
    ara::log::InitLogging("DPC", "DM", ara::log::LogLevel::kVerbose, (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));
    ara::log::Logger &mainLog{ara::log::CreateLogger("main", "DM data logging", ara::log::LogLevel::kVerbose)};
    mainLog.LogInfo() << "Decision module data...";
    GeneralWrapper gw(mainLog);

    BehaviorAnalysis i_behavior_analyzer_; // BehaviorAnalysis类

    // auto behavior_analyzer_node = std::make_shared<rclcpp::Node>("mpc_drv_ctAp_ba");
    // RosRecv<mpc_drv_msgs::msg::RoadInfo> road_model_recv("mpc_interface_drv_rm_p0040ms_rm2ba");
    // RosRecv<mpc_drv_msgs::msg::VehicleStateOutput> vehicle_state_recv("mpc_interface_drv_vse_p0010ms_vseinfo");
    // RosRecv<mpc_drv_msgs::msg::MsgSM2BA> system_manage_recv("mpc_interface_drv_sm_p0010ms_sm2ba");
    // RosRecv<mpc_drv_msgs::msg::ControlWaypoints> ehr_recv("mpc_interface_drv_ehr_p0050ms_ehr2ba");

    // std::placeholders::_1
    // auto subopt = rclcpp::SubscriptionOptions();
    // subopt.callback_group = behavior_analyzer_node->create_callback_group(rclcpp::CallbackGroupType::Reentrant);
    // subopt.callback_group = behavior_analyzer_node->create_callback_group(rclcpp::CallbackGroupType::MutuallyExclusive); // 20220910

    //    //               "mpc_interface_drv_rm_p0040ms_rm2ba", rclcpp::SensorDataQoS(), std::bind(
// auto sub_rm = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::RoadInfo>(
    //               &RosRecv<mpc_drv_msgs::msg::RoadInfo>::Callback, &road_model_recv, std::placeholders::_1), subopt);
    // auto sub_vse = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::VehicleStateOutput>(
    //                "mpc_interface_drv_vse_p0010ms_vseinfo", rclcpp::SensorDataQoS(), std::bind(
    //                &RosRecv<mpc_drv_msgs::msg::VehicleStateOutput>::Callback, &vehicle_state_recv, std::placeholders::_1), subopt);
    // auto sub_sm = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::MsgSM2BA>(
    //               "mpc_interface_drv_sm_p0010ms_sm2ba", rclcpp::SensorDataQoS(), std::bind(
    //               &RosRecv<mpc_drv_msgs::msg::MsgSM2BA>::Callback, &system_manage_recv, std::placeholders::_1), subopt);
    // auto sub_ehr = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::ControlWaypoints>(
    //                "mpc_interface_drv_ehr_p0050ms_ehr2ba", rclcpp::SensorDataQoS(), std::bind(
    //                &RosRecv<mpc_drv_msgs::msg::ControlWaypoints>::Callback, &ehr_recv, std::placeholders::_1), subopt);

    /* auto sub_rm = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::RoadInfo>
                  ("mpc_interface_drv_rm_p0040ms_rm2ba", rclcpp::QoS(5), std::bind(&BehaviorAnalysis::Callback4RMInfo, &i_behavior_analyzer_, std::placeholders::_1));
    auto sub_vse = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::VehicleStateOutput>
                  ("mpc_interface_drv_vse_p0010ms_vseinfo", rclcpp::QoS(5), std::bind(&BehaviorAnalysis::Callback4VSEInfo, &i_behavior_analyzer_, std::placeholders::_1));
    auto sub_sm = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::MsgSM2BA>
                  ("mpc_interface_drv_sm_p0010ms_sm2ba", rclcpp::QoS(5), std::bind(&BehaviorAnalysis::Callback4SMInfo, &i_behavior_analyzer_, std::placeholders::_1));
    auto sub_ehr = behavior_analyzer_node->create_subscription<mpc_drv_msgs::msg::ControlWaypoints>
                  ("mpc_interface_drv_ehr_p0050ms_ehr2ba", rclcpp::QoS(5), std::bind(&BehaviorAnalysis::Callback4EHRInfo, &i_behavior_analyzer_, std::placeholders::_1)); */

    // auto pub_sm = behavior_analyzer_node->create_publisher<mpc_drv_msgs::msg::MsgBA2SM>("mpc_interface_drv_ba_p0100ms_ba2sm", rclcpp::QoS(1));
    // auto pub_trplat = behavior_analyzer_node->create_publisher<mpc_drv_msgs::msg::MsgBA2TRPLat>("mpc_interface_drv_ba_p0100ms_ba2trpLat", rclcpp::QoS(1));
    // auto pub_trplongt = behavior_analyzer_node->create_publisher<mpc_drv_msgs::msg::MsgBA2TRPLongt>("mpc_interface_drv_ba_p0100ms_ba2trpLon", rclcpp::QoS(1));
    // #ifdef BA_Debug
    //     auto pub_baSelf = behavior_analyzer_node->create_publisher<mpc_drv_msgs::msg::MsgBA2Obs>("mpc_interface_drv_ba_p0100ms_ba2obs", rclcpp::QoS(1));
    // #endif
    // #ifdef PD_Debug
    //     auto pub_pddbg = behavior_analyzer_node->create_publisher<mpc_drv_msgs::msg::PDDebug>("mpc_interface_drv_ba_p0100ms_ba2pddbg", rclcpp::QoS(1));
    // #endif
    // #ifdef BA_RVIZ
    //     auto pub_barviz = behavior_analyzer_node->create_publisher<visualization_msgs::msg::Marker>("viz/mpc_drv_ctAp_ba/behavior_analyzer_disp", rclcpp::QoS(10));
    // #endif

    // executor.add_node(behavior_analyzer_node);
    LocalView local_view;
    dpc::RoadInfo road_model_recv;
    dpc::VED4DPC vehicle_state_recv;
    dpc::SM4Decision system_manage_recv;
    dpc::ControlWaypoints ehr_recv;

    dpc::DM2LongRefLine dm_2_long_ref_line;
    // auto spin_thread = std::thread([&executor]() { executor.spin(); });
    // Load_Parm(behavior_analyzer_node);
    // ros::Rate loop_rate(BEHAVIORANALYZERCYCLE); // 10hz
    while (1)
    {
        TIMERSTART(ba);
        // 20240330: uncomment UpdateLocalView() to assign external data to local_view


//        std::cout << "here is line: " << __LINE__ << std::endl;
        gw._VED2DM_Required.s.GetData(vehicle_state_recv);
        std::cout << "ved info got" << std::endl;
//        std::cout << "here is line: " << __LINE__ << std::endl;
//// internal struct
        gw._EM2DMRoadInfo_Required.s.GetData(road_model_recv);
        std::cout << "em info got" << std::endl;
        std::cout << "$$$$$$$ road_model_recv.car_position.ego_lane_id<" <<int(road_model_recv.car_position.ego_lane_id) << "\n";
        std::cout << "$$$$$$$ road_model_recv.lane_list.size()<" <<int(road_model_recv.lane_list.size())<< "\n";
//        std::cout << "here is line: " << __LINE__ << std::endl;
//// external struct
        // gw._EM2DMRMHeader_Required.s.GetData(i_behavior_analyzer_.input_BA.RM_RoadModel.rm_header);       // internal struct
        // gw._EM2DMIndex_Required.s.GetData(i_behavior_analyzer_.input_BA.RM_RoadModel.road_id);            // internal struct
        // road_model_recv.road_id = i_behavior_analyzer_.input_BA.RM_RoadModel.road_id;
        // gw._EM2DMCarPosition_Required.s.GetData(i_behavior_analyzer_.input_BA.RM_RoadModel.car_position); // internal struct
        // road_model_recv.car_position = i_behavior_analyzer_.input_BA.RM_RoadModel.car_position;
        // std::cout << "$$$$$$$ _behavior_analyzer_.input_BA.RM_RoadModel.car_position.ego_lane_id" <<+i_behavior_analyzer_.input_BA.RM_RoadModel.car_position.ego_lane_id << "\n";
        // gw._EM2DMLane_Required.s.GetData(DM_data_Lane);
        // gw._EM2DMLaneMarker_Required.s.GetData(DM_data_LaneMarker);
        // gw._EM2DMObject_Required.s.GetData(DM_data_Object);
        // gw._EM2DMRoadEdge_Required.s.GetData(DM_data_RoadEdge);
        // gw._EM2DMNeighborLane_Required.s.GetData(DM_data_NeighborLane);
        // gw._EM2DMCorridor_Required.s.GetData(DM_data_Corridor);
        // gw._EM2DMSamplingPoint_Required.s.GetData(DM_data_SamplingPoint);
        // gw._EM2DMLineColor_Required.s.GetData(DM_data_LineColor);
        // gw._EM2DMLineType_Required.s.GetData(DM_data_LineType);
        // gw._EM2DMObjectLocation_Required.s.GetData(DM_data_ObjectLocation);
        // gw._EM2DMSLPoint_Required.s.GetData(DM_data_SLPoint);
        // gw._EM2DMLaneControl_Required.s.GetData(DM_data_LaneControl);
        // gw._EM2DMLaneBoundary_Required.s.GetData(DM_data_LaneBoundary);
        // gw._EM2DMLineGeometry_Required.s.GetData(DM_data_LineGeometry);
        // gw._EM2DMRoadEdgeSegment_Required.s.GetData(DM_data_RoadEdgeSegment);
        // gw._SLAM2DMControlWayPoints_Required.s.GetData(ehr_recv);
        // gw._SLAM2DMAdjacentExtendLaneStruct_Required.s.GetData(DM_data_AdjacentExtendLaneStruct);
        // gw._SLAM2DMSMAStruct_Required.s.GetData(DM_data_SMAStruct);
        // gw._SLAM2DMWPExtendLaneStruct_Required.s.GetData(DM_data_WPExtendLaneStruct);
        // gw._SLAM2DMRemindWayPointStruct_Required.s.GetData(DM_data_RemindWayPointStruct);
        // gw._SLAM2DMControlWayPointStruct_Required.s.GetData(DM_data_ControlWayPointStruct);
        // gw._SLAM2DMMsgHeader_Required.s.GetData(DM_data_MsgHeader);
        // gw._SLAM2DMTransitLaneStruct_Required.s.GetData(DM_data_TransitLaneStruct);
        gw._SLAM2DMControlWayPoints_Required.s.GetData(ehr_recv);
        std::cout << "slam info got" << std::endl;
        gw._SM2Decision_Required.s.GetData(system_manage_recv); // 20240330: add SM related inputs receiving
        std::cout << "sm info got" << std::endl;

        UpdateLocalView(local_view,
                        road_model_recv,
                        vehicle_state_recv,
                        system_manage_recv,
                        ehr_recv);
        std::cout << "local view updated" << std::endl;
        i_behavior_analyzer_.BehaviorAnalyzerStartRun(local_view); // main function
        std::cout << "ba main pipeline finished" << std::endl;
        // add rolling counter for sm
        i_behavior_analyzer_.msg_BA2SM.ba_ldp_elk_md = i_behavior_analyzer_.CalcCycleCounter2SM();
        // i_behavior_analyzer_.msg_BA2SM.ba_ldp_elk_md = i_behavior_analyzer_.CalcCycleCounter2SM_InclOthrNodes(); // 20220819: add monitoring logic of received RM msg
        DLOG(INFO) << "counter2SM = " << int(i_behavior_analyzer_.msg_BA2SM.ba_ldp_elk_md) << std::endl;
        // cout << "counter2SM = " << int(i_behavior_analyzer_.msg_BA2SM.ba_ldp_elk_md) << std::endl;
        // pub_sm->publish(i_behavior_analyzer_.msg_BA2SM);  // publish sm msg
        DLOG(INFO) << "TRPLatSts: " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_trp_lat_sts) << std::endl;
        cout << "TRPLatSts: " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_trp_lat_sts) << std::endl;
//        DLOG(INFO) << "reference line c0: " << i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c0 << std::endl;
        cout << "reference line c0: " << i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c0 << std::endl;
        DLOG(INFO) << "optimal action to trplat: " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_opt_action) << std::endl;
        DLOG(INFO) << "optimal corridor id: " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_opt_corridor_id) << std::endl;
        DLOG(INFO) << "optimal action to sm: " << int(i_behavior_analyzer_.msg_BA2SM.ba_opt_action) << std::endl;
        DLOG(INFO) << "takeover request to sm: " << int(i_behavior_analyzer_.msg_BA2SM.ba_takeover_req) << std::endl;
        DLOG(INFO) << "lc abl obj id: " << int(i_behavior_analyzer_.msg_BA2SM.ba_alc_abl_tgt_id) << std::endl;
        // add rolling counter for trplat
        i_behavior_analyzer_.msg_BA2TRPLat.ba_rc4trp_lat = i_behavior_analyzer_.CalcRollCounter();
        i_behavior_analyzer_.msg_BA2TRPLat.ba_fusion_time_stamp = i_behavior_analyzer_.GetFusionTimeStamp();
        DLOG(INFO) << "counter2TRPLat = " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_rc4trp_lat) << std::endl;
        DLOG(INFO) << "TRPLatSts2TRPLat = " << int(i_behavior_analyzer_.msg_BA2TRPLat.ba_trp_lat_sts) << std::endl;
        std::cout << "TRPLongtSts: " << int(i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_indx_trp_lgt_sts) << std::endl;
        std::cout << "TRPLongtSts speed: " << i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_v_sv_setspd << std::endl;
        // pub_trplat->publish(i_behavior_analyzer_.msg_BA2TRPLat); // publish trplat msg
        // DLOG(INFO) << "TRPLongtSts: " << int(i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_indx_trp_lgt_sts) << std::endl;
        // DLOG(INFO) << "Target longitudinal distance: " << i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_d_tgt_longt_dist_iv << std::endl;
        // DLOG(INFO) << "Target longitudinal velocity: " << i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_v_tgt_longt_spd_iv << std::endl;
        // DLOG(INFO) << "Target id: " << int(i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_indx_blue_crrdr_tgt_id) << std::endl;
        DLOG(INFO) << "Speed limit flag: " << int(i_behavior_analyzer_.msg_BA2TRPLongt.ba_trp_indx_spdlim_typ) << std::endl;
        // pub_trplongt->publish(i_behavior_analyzer_.msg_BA2TRPLongt); // publish trplongt msg
        // #ifdef BA_Debug
        //     pub_baSelf->publish(i_behavior_analyzer_.msg_BA2Obs); // publish ba internal observation msg
        // #endif
        // #ifdef PD_Debug
        //     pub_pddbg->publish(i_behavior_analyzer_.msg_BA2PDDebug); // publish pd debug msg
        // #endif
        // #ifdef BA_RVIZ
        //     DisplayBARviz(i_behavior_analyzer_.msg_BA2SM,
        //                   i_behavior_analyzer_.msg_BA2TRPLat,
        //                   i_behavior_analyzer_.msg_BA2TRPLongt,
        //                   i_behavior_analyzer_.globalInfo,
        //                   i_behavior_analyzer_.BA_DircnIndReq_Deb,
        //                   i_behavior_analyzer_.input_BA,
        //                   pub_barviz,
        //                   behavior_analyzer_node);
        // #endif

        /* ros::spinOnce();
        loop_rate.sleep(); */
        TIMEREND(ba);
        // if (DURATION_ms(ba) > BEHAVIORANALYZERCYCLE)
        // {
        //     std::cout << "------------the program is running in low ""frequency-----------,    delta_time = " << DURATION_ms(ba) << std::endl;
        // }
        // else
        // {
        //     rclcpp::sleep_for(std::chrono::milliseconds(static_cast<long>(BEHAVIORANALYZERCYCLE - DURATION_ms(ba))));
        // }
        // executor.spin_some(); // single thread

        gw._DM2TRPCLong_Provide.s.SetData(i_behavior_analyzer_.msg_BA2TRPLongt);
        gw._DM2TRPCLong_Provide.Publish();

        // Fake DM2Lat data
//        i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c0 = 1.8888;
//        i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c1 = 0.3;
//        i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c2 = 0.05;
//        i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c3 = 0.02;

        std::cout << "WWWWW c0 :"<< i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c0 << std::endl;
        gw._DM2TRPCLat_Provide.s.SetData(i_behavior_analyzer_.msg_BA2TRPLat);
        gw._DM2TRPCLat_Provide.Publish();
        std::cout << "pin01" << std::endl;

        gw._DM2SM_Provide.s.SetData(i_behavior_analyzer_.msg_BA2SM);
        gw._DM2SM_Provide.Publish();
        std::cout << "pin02" << std::endl;

        gw._DM2SMObjectTrim_Provide.s.SetData(objectTrim);
        gw._DM2SMObjectTrim_Provide.Publish();
        std::cout << "pin03" << std::endl;

        // Publish ref line data for Long
        dm_2_long_ref_line.ba_ref_line_c0 = i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c0;
        dm_2_long_ref_line.ba_ref_line_c1 = i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c1;
        dm_2_long_ref_line.ba_ref_line_c2 = i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c2;
        dm_2_long_ref_line.ba_ref_line_c3 = i_behavior_analyzer_.msg_BA2TRPLat.ba_ref_line_c3;
        gw._DM2LongRefLine_Provide.s.SetData(dm_2_long_ref_line);
        gw._DM2LongRefLine_Provide.Publish();


        std::this_thread::sleep_for(std::chrono::milliseconds(50));

    }
    // executor.cancel();
    // spin_thread.join();
    return 0;
}
#endif
